/*  Sashi89 - TI89-Amiga communication program
 *  Copyright (C) 2000, 2001  Olivier Croquette (ocroquette@free.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>


#include "list.h"


void List_Init(struct List_List *list)
{
  list->first  = NULL;
  list->last   = NULL;
}

void *List_Push(struct List_List *list, size_t size)
{
  struct List_Node  *new;
  void              *content;

  new     = malloc(sizeof(struct List_Node));
  content = malloc(size);

  if ( ! new || ! content )
  {
    free(new);
    free(content);
    return(NULL);
  }

  new->prev = NULL;
  new->next = list->first;


  if ( list->first == NULL )
    list->last = new;
  else
    list->first->prev = new;

  list->first = new;

  printf("new=%p\n",new);
  printf("content=%p\n",content);

  new->content = content;
  return(content);
}

void *List_Top(struct List_List *list)
{
  if ( list->first == NULL )
    return(NULL);

  return(list->first->content);
}

void List_Pop(struct List_List *list)
{
  struct List_Node *newfirst;

  if ( ! list->first )
    return;

  newfirst = list->first->next;

  free(list->first->content);
  free(list->first);

  list->first = newfirst;
}

void List_Invert(struct List_List *list)
{
  struct List_Node *temp;
  struct List_Node *current;

  current = list->first;
  while ( current )
  {
    temp          = current->next;
    current->next = current->prev;
    current->prev = temp;

    current = temp;
  }

  temp        =   list->first;
  list->first =   list->last;
  list->last  =   temp;
}

/* Hack */
void List_Print(struct List_List *list)
{
  struct List_Node *current;

  current = list->first;
  while ( current )
  {
    printf("current = %p\n",current);
    printf("content = %p\n",current->content);
    printf("N%d\n",*((int*)current->content));
    current       = current->next;
  }

}
