/*  Sashi89 - TI89-Amiga communication program
 *  Copyright (C) 2000, 2001  Olivier Croquette (ocroquette@free.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

/*  Sashi89 - TI89-Amiga communication program
 *  Copyright (C) 2000, 2001  Olivier Croquette (ocroquette@free.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifndef PACKET_H
#define PACKET_H

#include <exec/types.h>

typedef struct
{
  UBYTE command;
  UBYTE *bytes;
  UBYTE checksum;
  unsigned int nb; /* number of bytes */
  unsigned int max; /* max number of bytes */

	/* Used only if command == COMMAND_OK ; tell if the TI was OK */
	int ok;

} Packet;


#define PACKET_ERROR      1
#define PACKET_TOOLITTLE  2

#define COMMAND_VARHEAD 0x06
#define COMMAND_WAITING 0x09
#define COMMAND_DATA    0x15
#define COMMAND_OK      0x56
#define COMMAND_CHKERR  0x5A
#define COMMAND_TEST    0x68
#define COMMAND_SCRDUMP 0x6D
#define COMMAND_DRCTCMD 0x87
#define COMMAND_EOT     0x92
#define COMMAND_REQUEST 0xA2

#define DEVICE_TI89_PC  0x98
#define DEVICE_PC_TI89  0x08

#define CODE_CHKERR 3


int   ti_sendpacket(Packet *packet);
int   ti_getpacket(Packet *packet);
int   ti_cp2packet(Packet *packet, int nb, UBYTE *bytes);
void  ti_freepacket(Packet *packet );
int   ti_allocpacket(Packet *packet, int nb);
void  ti_initpacket(Packet *packet);
int 	ti_printpacket(Packet *packet);


#endif
