/*  Sashi89 - TI89-Amiga communication program
 *  Copyright (C) 2000, 2001  Olivier Croquette (ocroquette@free.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

/*  Sashi89 - TI89-Amiga communication program
 *  Copyright (C) 2000, 2001  Olivier Croquette (ocroquette@free.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

/* Adapted from gtktilink, by Romain Lievin */
#define TI89_KEY_F1            0x10c
#define TI89_KEY_F2            0x10d
#define TI89_KEY_F3            0x10e
#define TI89_KEY_F4            0x10f
#define TI89_KEY_F5            0x110
#define TI89_KEY_F6            0x111
#define TI89_KEY_F7            0x112
#define TI89_KEY_F8            0x113

#define TI89_KEY_MODE          0x10a
#define TI89_KEY_CLEAR         0x107 /**/
#define TI89_KEY_LN            0x106
#define TI89_KEY_ESC           0x108 /**/
#define TI89_KEY_APPS          0x109 /**/
#define TI89_KEY_CR            0xd
#define TI89_KEY_SIN           0x103
#define TI89_KEY_COS           0x104
#define TI89_KEY_TAN           0x105
#define TI89_KEY_POW           0x5e
#define TI89_KEY_LPAR          0x28
#define TI89_KEY_RPAR          0x29
#define TI89_KEY_COMMA         0x2c
#define TI89_KEY_DIVIDE        0x2f
#define TI89_KEY_MULT          0x2a
#define TI89_KEY_MINUS         0x2d
#define TI89_KEY_PLUS          0x2b
#define TI89_KEY_STO           0x102
#define TI89_KEY_SPACE         0x20
#define TI89_KEY_EQUAL         0x3d
#define TI89_KEY_BS            0x101 /**/
#define TI89_KEY_THETA         0x88
#define TI89_KEY_NEG           0xad
#define TI89_KEY_POINT         0x2e
#define TI89_KEY_UP            0x151
#define TI89_KEY_UP_RG         0x156 /*?*/
#define TI89_KEY_RIGHT         0x158
#define TI89_KEY_DW_RG         0x15c /*?*/
#define TI89_KEY_DOWN          0x154
#define TI89_KEY_DW_LF         0x159 /*?*/
#define TI89_KEY_LEFT          0x152
#define TI89_KEY_UP_LF         0x153 /*?*/


/* ASCII : */
#define TI89_KEY_0             0x30
#define TI89_KEY_1             0x31
#define TI89_KEY_2             0x32
#define TI89_KEY_3             0x33
#define TI89_KEY_4             0x34
#define TI89_KEY_5             0x35
#define TI89_KEY_6             0x36
#define TI89_KEY_7             0x37
#define TI89_KEY_8             0x38
#define TI89_KEY_9             0x39
#define TI89_KEY_a             0x61
#define TI89_KEY_b             0x62
#define TI89_KEY_c             0x63
#define TI89_KEY_d             0x64
#define TI89_KEY_e             0x65
#define TI89_KEY_f             0x66
#define TI89_KEY_g             0x67
#define TI89_KEY_h             0x68
#define TI89_KEY_i             0x69
#define TI89_KEY_j             0x6a
#define TI89_KEY_k             0x6b
#define TI89_KEY_l             0x6c
#define TI89_KEY_m             0x6d
#define TI89_KEY_n             0x6e
#define TI89_KEY_o             0x6f
#define TI89_KEY_p             0x70
#define TI89_KEY_q             0x71
#define TI89_KEY_r             0x72
#define TI89_KEY_s             0x73
#define TI89_KEY_t             0x74
#define TI89_KEY_u             0x75
#define TI89_KEY_v             0x76
#define TI89_KEY_w             0x77
#define TI89_KEY_x             0x78
#define TI89_KEY_y             0x79
#define TI89_KEY_z             0x7a

/* Qualifiers : */
#define TI89_KEY_2ND           0x10
#define TI89_KEY_CTRL          0x20
#define TI89_KEY_SHIFT         0x40
#define TI89_KEY_LOCK          0x80
